/* ============================================================================================== *
 *                                                                                                *
 *                                       Xi Blockchain                                            *
 *                                                                                                *
 * ---------------------------------------------------------------------------------------------- *
 * This file is part of the Galaxia Project - Xi Blockchain                                       *
 * ---------------------------------------------------------------------------------------------- *
 *                                                                                                *
 * Copyright 2018-2019 Galaxia Project Developers                                                 *
 *                                                                                                *
 * This program is free software: you can redistribute it and/or modify it under the terms of the *
 * GNU General Public License as published by the Free Software Foundation, either version 3 of   *
 * the License, or (at your option) any later version.                                            *
 *                                                                                                *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;      *
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
 * See the GNU General Public License for more details.                                           *
 *                                                                                                *
 * You should have received a copy of the GNU General Public License along with this program.     *
 * If not, see <https://www.gnu.org/licenses/>.                                                   *
 *                                                                                                *
 * ============================================================================================== */

#include <gmock/gmock.h>

#include <Xi/Rct/Constants.h>
#include <Xi/Rct/Algorithm/KeyArithmetic.h>

#define XI_TESTSUITE T_Xi_Rct_KeyArithmetic

TEST(XI_TESTSUITE, AddPoint) {
  using namespace ::testing;
  using namespace ::Xi;
  using namespace ::Xi::Rct;

  std::vector<std::pair<KeyVector, Rct::Key>> Oracle{{
      {{{{{0xec, 0x50, 0x14, 0xac, 0xd7, 0x9d, 0xbc, 0x29, 0x3b, 0xd7, 0x6,  0x90, 0x2a, 0x23, 0x2e, 0xb5,
           0xb2, 0xaa, 0xd6, 0x6f, 0x42, 0x46, 0x4,  0xf4, 0x69, 0xc3, 0xaa, 0xb6, 0xa4, 0x38, 0xf6, 0xcb}},
         {{0xcb, 0x3e, 0xe3, 0x24, 0xab, 0xba, 0xf6, 0x8d, 0xa4, 0x32, 0x78, 0xb7, 0x12, 0x7e, 0x79, 0x6d,
           0x91, 0xb5, 0xcd, 0x58, 0x9a, 0xd4, 0x6,  0x2e, 0xf8, 0x7c, 0x3d, 0x20, 0xeb, 0x8b, 0x51, 0x45}}}},
       {{0xc,  0xa6, 0x67, 0x65, 0xad, 0x88, 0xd,  0x2d, 0xeb, 0x15, 0xdd, 0xe1, 0x5c, 0x96, 0xb3, 0x73,
         0xcf, 0x94, 0xf7, 0xe1, 0xe8, 0x3c, 0x54, 0xbb, 0x48, 0xe,  0x3c, 0x85, 0x77, 0x4b, 0xf6, 0x43}}},

      {{{{{0xfa, 0xc9, 0xfb, 0xb5, 0x8,  0x5,  0x3a, 0x72, 0x7,  0xc3, 0x91, 0x41, 0xc6, 0x90, 0xfd, 0x80,
           0xef, 0x8c, 0xd9, 0x99, 0x1d, 0x82, 0x86, 0xf9, 0x68, 0xca, 0x39, 0x92, 0x45, 0xb,  0xd5, 0x8e}},
         {{0xeb, 0xda, 0xec, 0x3,  0xd7, 0x8a, 0x5d, 0x93, 0x4c, 0xde, 0x2a, 0x24, 0xe4, 0x36, 0x7c, 0x33,
           0xff, 0xec, 0xf1, 0xdf, 0x23, 0xff, 0x5d, 0xf3, 0xa5, 0xdc, 0x8d, 0x15, 0xe4, 0x55, 0xb2, 0x9b}}}},
       {{0x98, 0x4b, 0xec, 0x70, 0xb0, 0x35, 0xb9, 0x6b, 0x9e, 0x61, 0xce, 0x95, 0xd0, 0x11, 0xbc, 0xc4,
         0xfd, 0x40, 0x98, 0x95, 0xf2, 0x1c, 0xdb, 0xed, 0x8e, 0xd2, 0xf1, 0xc2, 0x6b, 0xa,  0x4e, 0x32}}},

      {{{{{0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}},
         {{0xb1, 0x4e, 0x70, 0x30, 0xde, 0x97, 0xda, 0x36, 0xea, 0x77, 0x6b, 0xdc, 0xfd, 0x59, 0xed, 0x16,
           0xe0, 0x80, 0xca, 0x7b, 0xce, 0xf7, 0x3b, 0x8d, 0x4b, 0xd6, 0x49, 0xa6, 0x9e, 0x7a, 0x43, 0xff}}}},
       {{0xb1, 0x4e, 0x70, 0x30, 0xde, 0x97, 0xda, 0x36, 0xea, 0x77, 0x6b, 0xdc, 0xfd, 0x59, 0xed, 0x16,
         0xe0, 0x80, 0xca, 0x7b, 0xce, 0xf7, 0x3b, 0x8d, 0x4b, 0xd6, 0x49, 0xa6, 0x9e, 0x7a, 0x43, 0xff}}},

      {{{{{0xb1, 0x4e, 0x70, 0x30, 0xde, 0x97, 0xda, 0x36, 0xea, 0x77, 0x6b, 0xdc, 0xfd, 0x59, 0xed, 0x16,
           0xe0, 0x80, 0xca, 0x7b, 0xce, 0xf7, 0x3b, 0x8d, 0x4b, 0xd6, 0x49, 0xa6, 0x9e, 0x7a, 0x43, 0xff}},
         {{0x3b, 0xe2, 0xe6, 0x63, 0x26, 0xcf, 0x17, 0x4, 0xd2, 0x18, 0x9c, 0xab, 0xf,  0x4b, 0x49, 0x3a,
           0xcc, 0xc6, 0x3b, 0xb,  0x13, 0xae, 0x55, 0x5, 0x39, 0x37, 0x22, 0x69, 0x94, 0xfc, 0x75, 0x4c}}}},
       {{0x9c, 0xc1, 0xbb, 0x3e, 0x5a, 0xc5, 0x9f, 0xa2, 0x3,  0x58, 0xc7, 0xfe, 0xb,  0x18, 0x88, 0x39,
         0x7e, 0xce, 0x7b, 0x32, 0x55, 0x19, 0xad, 0x91, 0xd7, 0x94, 0xf9, 0xdd, 0xc1, 0x29, 0x7e, 0x4c}}},
  }};

  for (const auto& oracle : Oracle) {
    const auto& input = oracle.first;
    const auto& expected = oracle.second;
    auto returnVariant = key_add(input[0], input[1]);
    Rct::Key inplaceVariant;
    key_add_inplace(input[0], input[1], inplaceVariant);
    EXPECT_EQ(returnVariant, expected);
    EXPECT_EQ(inplaceVariant, expected);
  }
}
